/* See argparser_geo.h. */
/* Last edited on 2007-01-04 00:14:51 by stolfi */

/* Copyright  2003 Jorge Stolfi, Unicamp. See note at end of file. */

#include <argparser.h>
#include <argparser_geo.h>
#include <r3.h>
#include <r4.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <values.h>

r3_t argparser_get_next_r3(argparser_t *pp, double min, double max)
  { int i;
    r3_t p;
    for (i = 0; i < 3; i++)
      { p.c[i] = argparser_get_next_double(pp, min, max); }
    return p;
  } 

r4_t argparser_get_next_r4(argparser_t *pp, double min, double max)
  { int i;
    r4_t p;
    for (i = 0; i < 4; i++)
      { p.c[i] = argparser_get_next_double(pp, min, max); }
    return p;
  } 
  
r3_t argparser_get_next_dir(argparser_t *pp)
  { int i;
    r3_t d;
    for (i = 0; i < 3; i++)
      { d.c[i] = argparser_get_next_double(pp, -MAXDOUBLE, MAXDOUBLE); }
    r3_dir(&d, &d);
    return d;
  } 

/* Copyright  2003 by Jorge Stolfi.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appears in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty of any kind.
*/
 
