/* argparser_geo.h -- extends argparser.h for geometric args. */
/* Last edited on 2003-12-21 13:51:18 by stolfi */

#ifndef argparser_geo_H
#define argparser_geo_H

/* Copyright  2003 Jorge Stolfi, Unicamp. See note at end of file. */

/* This interface provides convenient tools for parsing command
  line arguments whose values are real vectors. */

#include <r3.h>
#include <r4.h>
#include <argparser.h>

r3_t argparser_get_next_r3(argparser_t *pp, double min, double max);
r4_t argparser_get_next_r4(argparser_t *pp, double min, double max);
  /* Parses with {argparser_get_next_double} the next {N} arguments,
    ({N=3} or {N=4}), which must be in the range {[min .. max]}. */

r3_t argparser_get_next_dir(argparser_t *pp);
  /* Same as {argparser_get_next_r3} but normalizes result to unit length. */

/* Copyright  2003 by Jorge Stolfi.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appears in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty of any kind.
*/

#endif
