/* See interval.h */
/* Last edited on 2007-01-04 00:15:08 by stolfi */

#include <interval.h>
#include <stdlib.h>

interval_t interval_split(interval_t v, interval_side_t dir)
  { 
    if (dir == 0)
      { return (interval_t){{ LO(v), (LO(v) + HI(v))/2 }}; }
    else
      { return (interval_t){{ (LO(v) + HI(v))/2, HI(v) }}; }
  }

interval_t interval_join(interval_t *u, interval_t *v)
  { double ulo = LO(*u), uhi = HI(*u);
    double vlo = LO(*v), vhi = HI(*v);
    if (ulo > uhi) 
      { return *v; }
    else if (vlo > vhi)
      { return *u; }
    else
      { interval_t w;
        LO(w) = (ulo < vlo ? ulo : vlo);
        HI(w) = (uhi > vhi ? uhi : vhi);
        return w;
      }
  }

interval_t interval_meet(interval_t *u, interval_t *v)
  { double ulo = LO(*u), uhi = HI(*u);
    double vlo = LO(*v), vhi = HI(*v);
    if (ulo > uhi)
      { return *u; }
    if (vlo > vhi)
      { return *v; }
    else
      { interval_t w;
        LO(w) = (ulo > vlo ? ulo : vlo);
        HI(w) = (uhi < vhi ? uhi : vhi);
        return w;
      }
  }

void interval_widen(interval_t *r, double margin)
  { LO(*r) = LO(*r) - margin;
    HI(*r) = HI(*r) + margin;
  }

void interval_adjust_ratio(interval_t *xr, interval_t *yr, double tx, double ty)
  { double dx = HI(*xr) - LO(*xr);
    double dy = HI(*yr) - LO(*yr);
    if (ty*dx > tx*dy)
      { double ey = (ty*dx/tx - dy)/2.0;
        LO(*yr) = LO(*yr) - ey;
        HI(*yr) = HI(*yr) + ey;
      }
    else if (ty*dx < tx*dy)
      { double ex = (tx*dy/ty - dx)/2.0;
        LO(*xr) = LO(*xr) - ex;
        HI(*xr) = HI(*xr) + ex;
      }
  }

